-module(lustre@element@html).
-compile([no_auto_import, nowarn_unused_vars, nowarn_unused_function, nowarn_nomatch]).

-export([html/2, text/1, base/1, head/2, link/1, meta/1, style/2, title/2, body/2, address/2, article/2, aside/2, footer/2, header/2, h1/2, h2/2, h3/2, h4/2, h5/2, h6/2, hgroup/2, main/2, nav/2, section/2, search/2, blockquote/2, dd/2, 'div'/2, dl/2, dt/2, figcaption/2, figure/2, hr/1, li/2, menu/2, ol/2, p/2, pre/2, ul/2, a/2, abbr/2, b/2, bdi/2, bdo/2, br/1, cite/2, code/2, data/2, dfn/2, em/2, i/2, kbd/2, mark/2, q/2, rp/2, rt/2, ruby/2, s/2, samp/2, small/2, span/2, strong/2, sub/2, sup/2, time/2, u/2, var/2, wbr/1, area/1, audio/2, img/1, map/2, track/1, video/2, embed/1, iframe/1, object/1, picture/2, portal/1, source/1, svg/2, math/2, canvas/1, noscript/2, script/2, del/2, ins/2, caption/2, col/1, colgroup/2, table/2, tbody/2, td/2, tfoot/2, th/2, thead/2, tr/2, button/2, datalist/2, fieldset/2, form/2, input/1, label/2, legend/2, meter/2, optgroup/2, option/2, output/2, progress/2, select/2, textarea/2, details/2, dialog/2, summary/2, slot/1, template/2]).

-spec html(
    list(lustre@internals@vdom:attribute(JTE)),
    list(lustre@internals@vdom:element(JTE))
) -> lustre@internals@vdom:element(JTE).
html(Attrs, Children) ->
    lustre@element:element(<<"html"/utf8>>, Attrs, Children).

-spec text(binary()) -> lustre@internals@vdom:element(any()).
text(Content) ->
    lustre@element:text(Content).

-spec base(list(lustre@internals@vdom:attribute(JTM))) -> lustre@internals@vdom:element(JTM).
base(Attrs) ->
    lustre@element:element(<<"base"/utf8>>, Attrs, []).

-spec head(
    list(lustre@internals@vdom:attribute(JTQ)),
    list(lustre@internals@vdom:element(JTQ))
) -> lustre@internals@vdom:element(JTQ).
head(Attrs, Children) ->
    lustre@element:element(<<"head"/utf8>>, Attrs, Children).

-spec link(list(lustre@internals@vdom:attribute(JTW))) -> lustre@internals@vdom:element(JTW).
link(Attrs) ->
    lustre@element:element(<<"link"/utf8>>, Attrs, []).

-spec meta(list(lustre@internals@vdom:attribute(JUA))) -> lustre@internals@vdom:element(JUA).
meta(Attrs) ->
    lustre@element:element(<<"meta"/utf8>>, Attrs, []).

-spec style(list(lustre@internals@vdom:attribute(JUE)), binary()) -> lustre@internals@vdom:element(JUE).
style(Attrs, Css) ->
    lustre@element:element(<<"style"/utf8>>, Attrs, [text(Css)]).

-spec title(list(lustre@internals@vdom:attribute(JUI)), binary()) -> lustre@internals@vdom:element(JUI).
title(Attrs, Content) ->
    lustre@element:element(<<"title"/utf8>>, Attrs, [text(Content)]).

-spec body(
    list(lustre@internals@vdom:attribute(JUM)),
    list(lustre@internals@vdom:element(JUM))
) -> lustre@internals@vdom:element(JUM).
body(Attrs, Children) ->
    lustre@element:element(<<"body"/utf8>>, Attrs, Children).

-spec address(
    list(lustre@internals@vdom:attribute(JUS)),
    list(lustre@internals@vdom:element(JUS))
) -> lustre@internals@vdom:element(JUS).
address(Attrs, Children) ->
    lustre@element:element(<<"address"/utf8>>, Attrs, Children).

-spec article(
    list(lustre@internals@vdom:attribute(JUY)),
    list(lustre@internals@vdom:element(JUY))
) -> lustre@internals@vdom:element(JUY).
article(Attrs, Children) ->
    lustre@element:element(<<"article"/utf8>>, Attrs, Children).

-spec aside(
    list(lustre@internals@vdom:attribute(JVE)),
    list(lustre@internals@vdom:element(JVE))
) -> lustre@internals@vdom:element(JVE).
aside(Attrs, Children) ->
    lustre@element:element(<<"aside"/utf8>>, Attrs, Children).

-spec footer(
    list(lustre@internals@vdom:attribute(JVK)),
    list(lustre@internals@vdom:element(JVK))
) -> lustre@internals@vdom:element(JVK).
footer(Attrs, Children) ->
    lustre@element:element(<<"footer"/utf8>>, Attrs, Children).

-spec header(
    list(lustre@internals@vdom:attribute(JVQ)),
    list(lustre@internals@vdom:element(JVQ))
) -> lustre@internals@vdom:element(JVQ).
header(Attrs, Children) ->
    lustre@element:element(<<"header"/utf8>>, Attrs, Children).

-spec h1(
    list(lustre@internals@vdom:attribute(JVW)),
    list(lustre@internals@vdom:element(JVW))
) -> lustre@internals@vdom:element(JVW).
h1(Attrs, Children) ->
    lustre@element:element(<<"h1"/utf8>>, Attrs, Children).

-spec h2(
    list(lustre@internals@vdom:attribute(JWC)),
    list(lustre@internals@vdom:element(JWC))
) -> lustre@internals@vdom:element(JWC).
h2(Attrs, Children) ->
    lustre@element:element(<<"h2"/utf8>>, Attrs, Children).

-spec h3(
    list(lustre@internals@vdom:attribute(JWI)),
    list(lustre@internals@vdom:element(JWI))
) -> lustre@internals@vdom:element(JWI).
h3(Attrs, Children) ->
    lustre@element:element(<<"h3"/utf8>>, Attrs, Children).

-spec h4(
    list(lustre@internals@vdom:attribute(JWO)),
    list(lustre@internals@vdom:element(JWO))
) -> lustre@internals@vdom:element(JWO).
h4(Attrs, Children) ->
    lustre@element:element(<<"h4"/utf8>>, Attrs, Children).

-spec h5(
    list(lustre@internals@vdom:attribute(JWU)),
    list(lustre@internals@vdom:element(JWU))
) -> lustre@internals@vdom:element(JWU).
h5(Attrs, Children) ->
    lustre@element:element(<<"h5"/utf8>>, Attrs, Children).

-spec h6(
    list(lustre@internals@vdom:attribute(JXA)),
    list(lustre@internals@vdom:element(JXA))
) -> lustre@internals@vdom:element(JXA).
h6(Attrs, Children) ->
    lustre@element:element(<<"h6"/utf8>>, Attrs, Children).

-spec hgroup(
    list(lustre@internals@vdom:attribute(JXG)),
    list(lustre@internals@vdom:element(JXG))
) -> lustre@internals@vdom:element(JXG).
hgroup(Attrs, Children) ->
    lustre@element:element(<<"hgroup"/utf8>>, Attrs, Children).

-spec main(
    list(lustre@internals@vdom:attribute(JXM)),
    list(lustre@internals@vdom:element(JXM))
) -> lustre@internals@vdom:element(JXM).
main(Attrs, Children) ->
    lustre@element:element(<<"main"/utf8>>, Attrs, Children).

-spec nav(
    list(lustre@internals@vdom:attribute(JXS)),
    list(lustre@internals@vdom:element(JXS))
) -> lustre@internals@vdom:element(JXS).
nav(Attrs, Children) ->
    lustre@element:element(<<"nav"/utf8>>, Attrs, Children).

-spec section(
    list(lustre@internals@vdom:attribute(JXY)),
    list(lustre@internals@vdom:element(JXY))
) -> lustre@internals@vdom:element(JXY).
section(Attrs, Children) ->
    lustre@element:element(<<"section"/utf8>>, Attrs, Children).

-spec search(
    list(lustre@internals@vdom:attribute(JYE)),
    list(lustre@internals@vdom:element(JYE))
) -> lustre@internals@vdom:element(JYE).
search(Attrs, Children) ->
    lustre@element:element(<<"search"/utf8>>, Attrs, Children).

-spec blockquote(
    list(lustre@internals@vdom:attribute(JYK)),
    list(lustre@internals@vdom:element(JYK))
) -> lustre@internals@vdom:element(JYK).
blockquote(Attrs, Children) ->
    lustre@element:element(<<"blockquote"/utf8>>, Attrs, Children).

-spec dd(
    list(lustre@internals@vdom:attribute(JYQ)),
    list(lustre@internals@vdom:element(JYQ))
) -> lustre@internals@vdom:element(JYQ).
dd(Attrs, Children) ->
    lustre@element:element(<<"dd"/utf8>>, Attrs, Children).

-spec 'div'(
    list(lustre@internals@vdom:attribute(JYW)),
    list(lustre@internals@vdom:element(JYW))
) -> lustre@internals@vdom:element(JYW).
'div'(Attrs, Children) ->
    lustre@element:element(<<"div"/utf8>>, Attrs, Children).

-spec dl(
    list(lustre@internals@vdom:attribute(JZC)),
    list(lustre@internals@vdom:element(JZC))
) -> lustre@internals@vdom:element(JZC).
dl(Attrs, Children) ->
    lustre@element:element(<<"dl"/utf8>>, Attrs, Children).

-spec dt(
    list(lustre@internals@vdom:attribute(JZI)),
    list(lustre@internals@vdom:element(JZI))
) -> lustre@internals@vdom:element(JZI).
dt(Attrs, Children) ->
    lustre@element:element(<<"dt"/utf8>>, Attrs, Children).

-spec figcaption(
    list(lustre@internals@vdom:attribute(JZO)),
    list(lustre@internals@vdom:element(JZO))
) -> lustre@internals@vdom:element(JZO).
figcaption(Attrs, Children) ->
    lustre@element:element(<<"figcaption"/utf8>>, Attrs, Children).

-spec figure(
    list(lustre@internals@vdom:attribute(JZU)),
    list(lustre@internals@vdom:element(JZU))
) -> lustre@internals@vdom:element(JZU).
figure(Attrs, Children) ->
    lustre@element:element(<<"figure"/utf8>>, Attrs, Children).

-spec hr(list(lustre@internals@vdom:attribute(KAA))) -> lustre@internals@vdom:element(KAA).
hr(Attrs) ->
    lustre@element:element(<<"hr"/utf8>>, Attrs, []).

-spec li(
    list(lustre@internals@vdom:attribute(KAE)),
    list(lustre@internals@vdom:element(KAE))
) -> lustre@internals@vdom:element(KAE).
li(Attrs, Children) ->
    lustre@element:element(<<"li"/utf8>>, Attrs, Children).

-spec menu(
    list(lustre@internals@vdom:attribute(KAK)),
    list(lustre@internals@vdom:element(KAK))
) -> lustre@internals@vdom:element(KAK).
menu(Attrs, Children) ->
    lustre@element:element(<<"menu"/utf8>>, Attrs, Children).

-spec ol(
    list(lustre@internals@vdom:attribute(KAQ)),
    list(lustre@internals@vdom:element(KAQ))
) -> lustre@internals@vdom:element(KAQ).
ol(Attrs, Children) ->
    lustre@element:element(<<"ol"/utf8>>, Attrs, Children).

-spec p(
    list(lustre@internals@vdom:attribute(KAW)),
    list(lustre@internals@vdom:element(KAW))
) -> lustre@internals@vdom:element(KAW).
p(Attrs, Children) ->
    lustre@element:element(<<"p"/utf8>>, Attrs, Children).

-spec pre(
    list(lustre@internals@vdom:attribute(KBC)),
    list(lustre@internals@vdom:element(KBC))
) -> lustre@internals@vdom:element(KBC).
pre(Attrs, Children) ->
    lustre@element:element(<<"pre"/utf8>>, Attrs, Children).

-spec ul(
    list(lustre@internals@vdom:attribute(KBI)),
    list(lustre@internals@vdom:element(KBI))
) -> lustre@internals@vdom:element(KBI).
ul(Attrs, Children) ->
    lustre@element:element(<<"ul"/utf8>>, Attrs, Children).

-spec a(
    list(lustre@internals@vdom:attribute(KBO)),
    list(lustre@internals@vdom:element(KBO))
) -> lustre@internals@vdom:element(KBO).
a(Attrs, Children) ->
    lustre@element:element(<<"a"/utf8>>, Attrs, Children).

-spec abbr(
    list(lustre@internals@vdom:attribute(KBU)),
    list(lustre@internals@vdom:element(KBU))
) -> lustre@internals@vdom:element(KBU).
abbr(Attrs, Children) ->
    lustre@element:element(<<"abbr"/utf8>>, Attrs, Children).

-spec b(
    list(lustre@internals@vdom:attribute(KCA)),
    list(lustre@internals@vdom:element(KCA))
) -> lustre@internals@vdom:element(KCA).
b(Attrs, Children) ->
    lustre@element:element(<<"b"/utf8>>, Attrs, Children).

-spec bdi(
    list(lustre@internals@vdom:attribute(KCG)),
    list(lustre@internals@vdom:element(KCG))
) -> lustre@internals@vdom:element(KCG).
bdi(Attrs, Children) ->
    lustre@element:element(<<"bdi"/utf8>>, Attrs, Children).

-spec bdo(
    list(lustre@internals@vdom:attribute(KCM)),
    list(lustre@internals@vdom:element(KCM))
) -> lustre@internals@vdom:element(KCM).
bdo(Attrs, Children) ->
    lustre@element:element(<<"bdo"/utf8>>, Attrs, Children).

-spec br(list(lustre@internals@vdom:attribute(KCS))) -> lustre@internals@vdom:element(KCS).
br(Attrs) ->
    lustre@element:element(<<"br"/utf8>>, Attrs, []).

-spec cite(
    list(lustre@internals@vdom:attribute(KCW)),
    list(lustre@internals@vdom:element(KCW))
) -> lustre@internals@vdom:element(KCW).
cite(Attrs, Children) ->
    lustre@element:element(<<"cite"/utf8>>, Attrs, Children).

-spec code(
    list(lustre@internals@vdom:attribute(KDC)),
    list(lustre@internals@vdom:element(KDC))
) -> lustre@internals@vdom:element(KDC).
code(Attrs, Children) ->
    lustre@element:element(<<"code"/utf8>>, Attrs, Children).

-spec data(
    list(lustre@internals@vdom:attribute(KDI)),
    list(lustre@internals@vdom:element(KDI))
) -> lustre@internals@vdom:element(KDI).
data(Attrs, Children) ->
    lustre@element:element(<<"data"/utf8>>, Attrs, Children).

-spec dfn(
    list(lustre@internals@vdom:attribute(KDO)),
    list(lustre@internals@vdom:element(KDO))
) -> lustre@internals@vdom:element(KDO).
dfn(Attrs, Children) ->
    lustre@element:element(<<"dfn"/utf8>>, Attrs, Children).

-spec em(
    list(lustre@internals@vdom:attribute(KDU)),
    list(lustre@internals@vdom:element(KDU))
) -> lustre@internals@vdom:element(KDU).
em(Attrs, Children) ->
    lustre@element:element(<<"em"/utf8>>, Attrs, Children).

-spec i(
    list(lustre@internals@vdom:attribute(KEA)),
    list(lustre@internals@vdom:element(KEA))
) -> lustre@internals@vdom:element(KEA).
i(Attrs, Children) ->
    lustre@element:element(<<"i"/utf8>>, Attrs, Children).

-spec kbd(
    list(lustre@internals@vdom:attribute(KEG)),
    list(lustre@internals@vdom:element(KEG))
) -> lustre@internals@vdom:element(KEG).
kbd(Attrs, Children) ->
    lustre@element:element(<<"kbd"/utf8>>, Attrs, Children).

-spec mark(
    list(lustre@internals@vdom:attribute(KEM)),
    list(lustre@internals@vdom:element(KEM))
) -> lustre@internals@vdom:element(KEM).
mark(Attrs, Children) ->
    lustre@element:element(<<"mark"/utf8>>, Attrs, Children).

-spec q(
    list(lustre@internals@vdom:attribute(KES)),
    list(lustre@internals@vdom:element(KES))
) -> lustre@internals@vdom:element(KES).
q(Attrs, Children) ->
    lustre@element:element(<<"q"/utf8>>, Attrs, Children).

-spec rp(
    list(lustre@internals@vdom:attribute(KEY)),
    list(lustre@internals@vdom:element(KEY))
) -> lustre@internals@vdom:element(KEY).
rp(Attrs, Children) ->
    lustre@element:element(<<"rp"/utf8>>, Attrs, Children).

-spec rt(
    list(lustre@internals@vdom:attribute(KFE)),
    list(lustre@internals@vdom:element(KFE))
) -> lustre@internals@vdom:element(KFE).
rt(Attrs, Children) ->
    lustre@element:element(<<"rt"/utf8>>, Attrs, Children).

-spec ruby(
    list(lustre@internals@vdom:attribute(KFK)),
    list(lustre@internals@vdom:element(KFK))
) -> lustre@internals@vdom:element(KFK).
ruby(Attrs, Children) ->
    lustre@element:element(<<"ruby"/utf8>>, Attrs, Children).

-spec s(
    list(lustre@internals@vdom:attribute(KFQ)),
    list(lustre@internals@vdom:element(KFQ))
) -> lustre@internals@vdom:element(KFQ).
s(Attrs, Children) ->
    lustre@element:element(<<"s"/utf8>>, Attrs, Children).

-spec samp(
    list(lustre@internals@vdom:attribute(KFW)),
    list(lustre@internals@vdom:element(KFW))
) -> lustre@internals@vdom:element(KFW).
samp(Attrs, Children) ->
    lustre@element:element(<<"samp"/utf8>>, Attrs, Children).

-spec small(
    list(lustre@internals@vdom:attribute(KGC)),
    list(lustre@internals@vdom:element(KGC))
) -> lustre@internals@vdom:element(KGC).
small(Attrs, Children) ->
    lustre@element:element(<<"small"/utf8>>, Attrs, Children).

-spec span(
    list(lustre@internals@vdom:attribute(KGI)),
    list(lustre@internals@vdom:element(KGI))
) -> lustre@internals@vdom:element(KGI).
span(Attrs, Children) ->
    lustre@element:element(<<"span"/utf8>>, Attrs, Children).

-spec strong(
    list(lustre@internals@vdom:attribute(KGO)),
    list(lustre@internals@vdom:element(KGO))
) -> lustre@internals@vdom:element(KGO).
strong(Attrs, Children) ->
    lustre@element:element(<<"strong"/utf8>>, Attrs, Children).

-spec sub(
    list(lustre@internals@vdom:attribute(KGU)),
    list(lustre@internals@vdom:element(KGU))
) -> lustre@internals@vdom:element(KGU).
sub(Attrs, Children) ->
    lustre@element:element(<<"sub"/utf8>>, Attrs, Children).

-spec sup(
    list(lustre@internals@vdom:attribute(KHA)),
    list(lustre@internals@vdom:element(KHA))
) -> lustre@internals@vdom:element(KHA).
sup(Attrs, Children) ->
    lustre@element:element(<<"sup"/utf8>>, Attrs, Children).

-spec time(
    list(lustre@internals@vdom:attribute(KHG)),
    list(lustre@internals@vdom:element(KHG))
) -> lustre@internals@vdom:element(KHG).
time(Attrs, Children) ->
    lustre@element:element(<<"time"/utf8>>, Attrs, Children).

-spec u(
    list(lustre@internals@vdom:attribute(KHM)),
    list(lustre@internals@vdom:element(KHM))
) -> lustre@internals@vdom:element(KHM).
u(Attrs, Children) ->
    lustre@element:element(<<"u"/utf8>>, Attrs, Children).

-spec var(
    list(lustre@internals@vdom:attribute(KHS)),
    list(lustre@internals@vdom:element(KHS))
) -> lustre@internals@vdom:element(KHS).
var(Attrs, Children) ->
    lustre@element:element(<<"var"/utf8>>, Attrs, Children).

-spec wbr(list(lustre@internals@vdom:attribute(KHY))) -> lustre@internals@vdom:element(KHY).
wbr(Attrs) ->
    lustre@element:element(<<"wbr"/utf8>>, Attrs, []).

-spec area(list(lustre@internals@vdom:attribute(KIC))) -> lustre@internals@vdom:element(KIC).
area(Attrs) ->
    lustre@element:element(<<"area"/utf8>>, Attrs, []).

-spec audio(
    list(lustre@internals@vdom:attribute(KIG)),
    list(lustre@internals@vdom:element(KIG))
) -> lustre@internals@vdom:element(KIG).
audio(Attrs, Children) ->
    lustre@element:element(<<"audio"/utf8>>, Attrs, Children).

-spec img(list(lustre@internals@vdom:attribute(KIM))) -> lustre@internals@vdom:element(KIM).
img(Attrs) ->
    lustre@element:element(<<"img"/utf8>>, Attrs, []).

-spec map(
    list(lustre@internals@vdom:attribute(KIQ)),
    list(lustre@internals@vdom:element(KIQ))
) -> lustre@internals@vdom:element(KIQ).
map(Attrs, Children) ->
    lustre@element:element(<<"map"/utf8>>, Attrs, Children).

-spec track(list(lustre@internals@vdom:attribute(KIW))) -> lustre@internals@vdom:element(KIW).
track(Attrs) ->
    lustre@element:element(<<"track"/utf8>>, Attrs, []).

-spec video(
    list(lustre@internals@vdom:attribute(KJA)),
    list(lustre@internals@vdom:element(KJA))
) -> lustre@internals@vdom:element(KJA).
video(Attrs, Children) ->
    lustre@element:element(<<"video"/utf8>>, Attrs, Children).

-spec embed(list(lustre@internals@vdom:attribute(KJG))) -> lustre@internals@vdom:element(KJG).
embed(Attrs) ->
    lustre@element:element(<<"embed"/utf8>>, Attrs, []).

-spec iframe(list(lustre@internals@vdom:attribute(KJK))) -> lustre@internals@vdom:element(KJK).
iframe(Attrs) ->
    lustre@element:element(<<"iframe"/utf8>>, Attrs, []).

-spec object(list(lustre@internals@vdom:attribute(KJO))) -> lustre@internals@vdom:element(KJO).
object(Attrs) ->
    lustre@element:element(<<"object"/utf8>>, Attrs, []).

-spec picture(
    list(lustre@internals@vdom:attribute(KJS)),
    list(lustre@internals@vdom:element(KJS))
) -> lustre@internals@vdom:element(KJS).
picture(Attrs, Children) ->
    lustre@element:element(<<"picture"/utf8>>, Attrs, Children).

-spec portal(list(lustre@internals@vdom:attribute(KJY))) -> lustre@internals@vdom:element(KJY).
portal(Attrs) ->
    lustre@element:element(<<"portal"/utf8>>, Attrs, []).

-spec source(list(lustre@internals@vdom:attribute(KKC))) -> lustre@internals@vdom:element(KKC).
source(Attrs) ->
    lustre@element:element(<<"source"/utf8>>, Attrs, []).

-spec svg(
    list(lustre@internals@vdom:attribute(KKG)),
    list(lustre@internals@vdom:element(KKG))
) -> lustre@internals@vdom:element(KKG).
svg(Attrs, Children) ->
    lustre@element:namespaced(
        <<"http://www.w3.org/2000/svg"/utf8>>,
        <<"svg"/utf8>>,
        Attrs,
        Children
    ).

-spec math(
    list(lustre@internals@vdom:attribute(KKM)),
    list(lustre@internals@vdom:element(KKM))
) -> lustre@internals@vdom:element(KKM).
math(Attrs, Children) ->
    lustre@element:element(<<"math"/utf8>>, Attrs, Children).

-spec canvas(list(lustre@internals@vdom:attribute(KKS))) -> lustre@internals@vdom:element(KKS).
canvas(Attrs) ->
    lustre@element:element(<<"canvas"/utf8>>, Attrs, []).

-spec noscript(
    list(lustre@internals@vdom:attribute(KKW)),
    list(lustre@internals@vdom:element(KKW))
) -> lustre@internals@vdom:element(KKW).
noscript(Attrs, Children) ->
    lustre@element:element(<<"noscript"/utf8>>, Attrs, Children).

-spec script(list(lustre@internals@vdom:attribute(KLC)), binary()) -> lustre@internals@vdom:element(KLC).
script(Attrs, Js) ->
    lustre@element:element(<<"script"/utf8>>, Attrs, [text(Js)]).

-spec del(
    list(lustre@internals@vdom:attribute(KLG)),
    list(lustre@internals@vdom:element(KLG))
) -> lustre@internals@vdom:element(KLG).
del(Attrs, Children) ->
    lustre@element:element(<<"del"/utf8>>, Attrs, Children).

-spec ins(
    list(lustre@internals@vdom:attribute(KLM)),
    list(lustre@internals@vdom:element(KLM))
) -> lustre@internals@vdom:element(KLM).
ins(Attrs, Children) ->
    lustre@element:element(<<"ins"/utf8>>, Attrs, Children).

-spec caption(
    list(lustre@internals@vdom:attribute(KLS)),
    list(lustre@internals@vdom:element(KLS))
) -> lustre@internals@vdom:element(KLS).
caption(Attrs, Children) ->
    lustre@element:element(<<"caption"/utf8>>, Attrs, Children).

-spec col(list(lustre@internals@vdom:attribute(KLY))) -> lustre@internals@vdom:element(KLY).
col(Attrs) ->
    lustre@element:element(<<"col"/utf8>>, Attrs, []).

-spec colgroup(
    list(lustre@internals@vdom:attribute(KMC)),
    list(lustre@internals@vdom:element(KMC))
) -> lustre@internals@vdom:element(KMC).
colgroup(Attrs, Children) ->
    lustre@element:element(<<"colgroup"/utf8>>, Attrs, Children).

-spec table(
    list(lustre@internals@vdom:attribute(KMI)),
    list(lustre@internals@vdom:element(KMI))
) -> lustre@internals@vdom:element(KMI).
table(Attrs, Children) ->
    lustre@element:element(<<"table"/utf8>>, Attrs, Children).

-spec tbody(
    list(lustre@internals@vdom:attribute(KMO)),
    list(lustre@internals@vdom:element(KMO))
) -> lustre@internals@vdom:element(KMO).
tbody(Attrs, Children) ->
    lustre@element:element(<<"tbody"/utf8>>, Attrs, Children).

-spec td(
    list(lustre@internals@vdom:attribute(KMU)),
    list(lustre@internals@vdom:element(KMU))
) -> lustre@internals@vdom:element(KMU).
td(Attrs, Children) ->
    lustre@element:element(<<"td"/utf8>>, Attrs, Children).

-spec tfoot(
    list(lustre@internals@vdom:attribute(KNA)),
    list(lustre@internals@vdom:element(KNA))
) -> lustre@internals@vdom:element(KNA).
tfoot(Attrs, Children) ->
    lustre@element:element(<<"tfoot"/utf8>>, Attrs, Children).

-spec th(
    list(lustre@internals@vdom:attribute(KNG)),
    list(lustre@internals@vdom:element(KNG))
) -> lustre@internals@vdom:element(KNG).
th(Attrs, Children) ->
    lustre@element:element(<<"th"/utf8>>, Attrs, Children).

-spec thead(
    list(lustre@internals@vdom:attribute(KNM)),
    list(lustre@internals@vdom:element(KNM))
) -> lustre@internals@vdom:element(KNM).
thead(Attrs, Children) ->
    lustre@element:element(<<"thead"/utf8>>, Attrs, Children).

-spec tr(
    list(lustre@internals@vdom:attribute(KNS)),
    list(lustre@internals@vdom:element(KNS))
) -> lustre@internals@vdom:element(KNS).
tr(Attrs, Children) ->
    lustre@element:element(<<"tr"/utf8>>, Attrs, Children).

-spec button(
    list(lustre@internals@vdom:attribute(KNY)),
    list(lustre@internals@vdom:element(KNY))
) -> lustre@internals@vdom:element(KNY).
button(Attrs, Children) ->
    lustre@element:element(<<"button"/utf8>>, Attrs, Children).

-spec datalist(
    list(lustre@internals@vdom:attribute(KOE)),
    list(lustre@internals@vdom:element(KOE))
) -> lustre@internals@vdom:element(KOE).
datalist(Attrs, Children) ->
    lustre@element:element(<<"datalist"/utf8>>, Attrs, Children).

-spec fieldset(
    list(lustre@internals@vdom:attribute(KOK)),
    list(lustre@internals@vdom:element(KOK))
) -> lustre@internals@vdom:element(KOK).
fieldset(Attrs, Children) ->
    lustre@element:element(<<"fieldset"/utf8>>, Attrs, Children).

-spec form(
    list(lustre@internals@vdom:attribute(KOQ)),
    list(lustre@internals@vdom:element(KOQ))
) -> lustre@internals@vdom:element(KOQ).
form(Attrs, Children) ->
    lustre@element:element(<<"form"/utf8>>, Attrs, Children).

-spec input(list(lustre@internals@vdom:attribute(KOW))) -> lustre@internals@vdom:element(KOW).
input(Attrs) ->
    lustre@element:element(<<"input"/utf8>>, Attrs, []).

-spec label(
    list(lustre@internals@vdom:attribute(KPA)),
    list(lustre@internals@vdom:element(KPA))
) -> lustre@internals@vdom:element(KPA).
label(Attrs, Children) ->
    lustre@element:element(<<"label"/utf8>>, Attrs, Children).

-spec legend(
    list(lustre@internals@vdom:attribute(KPG)),
    list(lustre@internals@vdom:element(KPG))
) -> lustre@internals@vdom:element(KPG).
legend(Attrs, Children) ->
    lustre@element:element(<<"legend"/utf8>>, Attrs, Children).

-spec meter(
    list(lustre@internals@vdom:attribute(KPM)),
    list(lustre@internals@vdom:element(KPM))
) -> lustre@internals@vdom:element(KPM).
meter(Attrs, Children) ->
    lustre@element:element(<<"meter"/utf8>>, Attrs, Children).

-spec optgroup(
    list(lustre@internals@vdom:attribute(KPS)),
    list(lustre@internals@vdom:element(KPS))
) -> lustre@internals@vdom:element(KPS).
optgroup(Attrs, Children) ->
    lustre@element:element(<<"optgroup"/utf8>>, Attrs, Children).

-spec option(list(lustre@internals@vdom:attribute(KPY)), binary()) -> lustre@internals@vdom:element(KPY).
option(Attrs, Label) ->
    lustre@element:element(
        <<"option"/utf8>>,
        Attrs,
        [lustre@element:text(Label)]
    ).

-spec output(
    list(lustre@internals@vdom:attribute(KQC)),
    list(lustre@internals@vdom:element(KQC))
) -> lustre@internals@vdom:element(KQC).
output(Attrs, Children) ->
    lustre@element:element(<<"output"/utf8>>, Attrs, Children).

-spec progress(
    list(lustre@internals@vdom:attribute(KQI)),
    list(lustre@internals@vdom:element(KQI))
) -> lustre@internals@vdom:element(KQI).
progress(Attrs, Children) ->
    lustre@element:element(<<"progress"/utf8>>, Attrs, Children).

-spec select(
    list(lustre@internals@vdom:attribute(KQO)),
    list(lustre@internals@vdom:element(KQO))
) -> lustre@internals@vdom:element(KQO).
select(Attrs, Children) ->
    lustre@element:element(<<"select"/utf8>>, Attrs, Children).

-spec textarea(list(lustre@internals@vdom:attribute(KQU)), binary()) -> lustre@internals@vdom:element(KQU).
textarea(Attrs, Content) ->
    lustre@element:element(
        <<"textarea"/utf8>>,
        Attrs,
        [lustre@element:text(Content)]
    ).

-spec details(
    list(lustre@internals@vdom:attribute(KQY)),
    list(lustre@internals@vdom:element(KQY))
) -> lustre@internals@vdom:element(KQY).
details(Attrs, Children) ->
    lustre@element:element(<<"details"/utf8>>, Attrs, Children).

-spec dialog(
    list(lustre@internals@vdom:attribute(KRE)),
    list(lustre@internals@vdom:element(KRE))
) -> lustre@internals@vdom:element(KRE).
dialog(Attrs, Children) ->
    lustre@element:element(<<"dialog"/utf8>>, Attrs, Children).

-spec summary(
    list(lustre@internals@vdom:attribute(KRK)),
    list(lustre@internals@vdom:element(KRK))
) -> lustre@internals@vdom:element(KRK).
summary(Attrs, Children) ->
    lustre@element:element(<<"summary"/utf8>>, Attrs, Children).

-spec slot(list(lustre@internals@vdom:attribute(KRQ))) -> lustre@internals@vdom:element(KRQ).
slot(Attrs) ->
    lustre@element:element(<<"slot"/utf8>>, Attrs, []).

-spec template(
    list(lustre@internals@vdom:attribute(KRU)),
    list(lustre@internals@vdom:element(KRU))
) -> lustre@internals@vdom:element(KRU).
template(Attrs, Children) ->
    lustre@element:element(<<"template"/utf8>>, Attrs, Children).
